local opt = vim.opt

-- Don't highlight on search
opt.hlsearch = false
opt.incsearch = true

-- Enable line numbers by default
opt.number = true
opt.relativenumber = true

-- Tab settings
opt.tabstop = 4
opt.softtabstop = 4
opt.shiftwidth = 4
opt.expandtab = true

-- Enable smart indenting
opt.smartindent = true

-- Enable the mouse, just to have it
opt.mouse = 'a'

-- Enable break indent
opt.breakindent = true

-- History settings
opt.undofile = true
opt.undodir = os.getenv("HOME") .. "/.local/state/nvim"
opt.swapfile = true
opt.swapfile = true

-- Case-insensitive searching UNLESS \C or capital in search
opt.ignorecase = true
opt.smartcase = true

-- Keep signcolumn on by default
opt.signcolumn = 'yes'

-- Decrease update time
opt.updatetime = 50
opt.timeoutlen = 300

-- Set completeopt to have a better completion experience
opt.completeopt = 'menuone,noselect'

-- Enable true color support
opt.termguicolors = true

-- Enable scroll off
opt.scrolloff = 8

-- Color the 80 column
opt.colorcolumn = "80"

-- Don't show mode I'm in, already have a nice status line for that
opt.showmode = false

-- Enable global status line
opt.laststatus = 3

-- Better split options
opt.splitbelow = true
opt.splitright = true
